#
# From DAS on Tcl Wiki
#
# Daniel Steffen - http://www.maths.mq.edu.au/~steffen/tcltk

proc balloon {w help} {
    bind $w <Any-Enter> "after 1000 [list balloon:show %W [list $help]]"
    bind $w <Any-Leave> "destroy %W.balloon"
}

proc balloon:show {w arg} {
    if {![string match [eval winfo containing  [winfo pointerxy .]] $w]} {
        return
    }
    set top $w.balloon
    catch {destroy $top}
    toplevel $top -borderwidth 1 -background black
    wm overrideredirect $top 1
    if {$::tcl_platform(platform) == "macintosh"} {
     unsupported1 style $top floating sideTitlebar
    }
    pack [message $top.txt -aspect 200 -background lightyellow \
            -font fixed -text $arg]
    set wmx [winfo rootx $w]
    set wmy [expr [winfo rooty $w]+[winfo height $w]]
    wm geometry $top \
      [winfo reqwidth $top.txt]x[winfo reqheight $top.txt]+$wmx+$wmy
    raise $top
}

if {[info exists argv] && ([string first -testBalloon $argv] >= 0)} {
 # Example:
  button  .b -text Exit -command exit
  balloon .b "Push me if you're done with this"
  pack    .b
}
